package com.virtual.plat.server.publiccloud.rest;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.google.common.collect.Sets;
import com.virtual.common.AppException;
import com.virtual.common.ErrorCodes;
import com.virtual.plat.client.rpc.RpcResult;
import com.virtual.plat.server.cloudos.CloudOSMgr;
import com.virtual.plat.server.cloudos.deployment.entity.DeployedDomain;
import com.virtual.plat.server.cloudos.deployment.entity.DeployedPacking;
import com.virtual.plat.server.cloudos.entity.CloudOSAdvContent;
import com.virtual.plat.server.cloudos.entity.CloudOSFlavor;
import com.virtual.plat.server.cloudos.entity.CloudOSFlavorAdvance;
import com.virtual.plat.server.cloudos.entity.CloudOSFlavorBasic;
import com.virtual.plat.server.cloudos.entity.CloudOSNetwork;
import com.virtual.plat.server.cloudos.entity.CloudOSResource;
import com.virtual.plat.server.cloudos.entity.CloudOSSubnet;
import com.virtual.plat.server.cloudos.entity.CloudOSTemplet;
import com.virtual.plat.server.cloudos.entity.CloudOSVm;
import com.virtual.plat.server.cloudos.entity.CloudOSVmStatus;
import com.virtual.plat.server.cloudos.pool.CloudOSClient;
import com.virtual.plat.server.cloudos.pool.CloudOSConnectionManager;
import com.virtual.plat.server.controller.entity.CpuAndMemory;
import com.virtual.plat.server.controller.entity.ResourcePoolPo;
import com.virtual.plat.server.controller.entity.StoragePo;
import com.virtual.plat.server.entity.Cluster;
import com.virtual.plat.server.entity.Domain;
import com.virtual.plat.server.entity.PublicCloud;
import com.virtual.plat.server.http.RespEntity;
import com.virtual.plat.server.publiccloud.rest.BaseCloud;
import com.virtual.plat.server.publiccloud.rest.Cloud;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class CloudOsCloud extends Cloud implements CloudOSMgr {

   private CloudOSConnectionManager a = null;
   public static final String CLOUDOS_VMLIST_URL = "/v2/%s/servers/detail";
   public static final String CLOUDOS_VMTEMP_URL = "/v2/images";
   public static final String CLOUDOS_FLAVOR_URL = "/v2/%s/flavors/detail";
   private static Log b = LogFactory.getLog(BaseCloud.class);
   public static final long VIRTUAL_DOMAIN_ID = -1L;


   public CloudOsCloud(CloudOSConnectionManager var1, PublicCloud var2) {
      super(var2);
      this.a = var1;
   }

   private List a(List var1, long var2, Map var4, Map var5) {
      ArrayList var6 = Lists.newArrayList();
      Iterator var10 = var1.iterator();

      while(var10.hasNext()) {
         CloudOSVm var7;
         String var8 = (var7 = (CloudOSVm)var10.next()).getFlavor().getId();
         CloudOSFlavor var12 = (CloudOSFlavor)var5.get(var8);
         String var9 = var7.getImage().getId();
         Domain var13 = (Domain)var4.get(var9);
         Domain var11 = a((CloudOSVm)var7, var2, (CloudOSFlavor)var12, (Domain)var13);
         var6.add(var11);
      }

      return var6;
   }

   private static Domain a(CloudOSVm var0, long var1, CloudOSFlavor var3, Domain var4) {
      Domain var5;
      (var5 = new Domain()).setPublicCloudId(Long.valueOf(var1));
      var5.setCloudType(Integer.valueOf(5));
      var5.setUniqueKey(var0.getUuid());
      var5.setForeignId(Long.valueOf(-1L));
      var5.setStatus(var0.getCicStatus());
      var5.setTitle(var0.getName());
      var5.setDomainName(var0.getName());
      var5.setEnable(Integer.valueOf(1));
      if(var0.getMetadata() != null) {
         var5.setClusterKey(var0.getMetadata().getZoneUuid());
         var5.setDescription(var0.getMetadata().getDescription());
      }

      var5.setUuid(var0.getUuid() == null?"":var0.getUuid());
      SimpleDateFormat var7 = new SimpleDateFormat("yyyy-MM-dd\'T\'HH:mm:ss\'Z\'");
      new Date();
      Date var6 = var7.parse(var0.getCreateDate());
      var5.setCreateDate(var6);
      if(var3 != null) {
         var5.setCpu(Integer.valueOf(var3.getVcpus()));
         var5.setMemory(Long.valueOf((long)var3.getRam()));
         var5.setStorageCapacity(Long.valueOf((long)var3.getDisk() << 10));
      }

      if(var4 != null) {
         var5.setSystem(var4.getSystem());
         var5.setOsVersion(var4.getOsVersion());
      }

      return var5;
   }

   private Map a(List var1, long var2) {
      HashMap var4 = Maps.newHashMap();
      Iterator var7 = var1.iterator();

      while(var7.hasNext()) {
         CloudOSTemplet var5;
         Domain var6 = a((CloudOSTemplet)(var5 = (CloudOSTemplet)var7.next()), var2);
         var4.put(var5.getId(), var6);
      }

      return var4;
   }

   private static Domain a(CloudOSTemplet var0, long var1) {
      Domain var3;
      (var3 = new Domain()).setPublicCloudId(Long.valueOf(var1));
      var3.setCloudType(Integer.valueOf(5));
      var3.setUniqueKey(var0.getId());
      var3.setForeignId(Long.valueOf(-1L));
      var3.setHostId(Long.valueOf(0L));
      var3.setClusterId(Long.valueOf(0L));
      var3.setHostPoolId(Long.valueOf(0L));
      var3.setStatus("");
      var3.setTitle(var0.getName());
      var3.setDomainName(var0.getName());
      var3.setEnable(Integer.valueOf(2));
      var3.setDescription(var0.getDescription());
      var3.setUuid(var0.getId());
      var3.setCpu(Integer.valueOf(var0.getMinCpu()));
      var3.setMemory(Long.valueOf((long)var0.getMinRam()));
      var3.setStorageCapacity(Long.valueOf((long)var0.getMinDisk() << 10));
      if(!StringUtils.isEmpty(var0.getCasOstype())) {
         String[] var4 = var0.getCasOstype().split("\\|");
         var3.setOsVersion(var4[1]);
         var3.setSystem(Integer.valueOf("windows".equals(var4[0])?0:1));
      }

      SimpleDateFormat var5 = new SimpleDateFormat("yyyy-MM-dd\'T\'HH:mm:ss\'Z\'");
      new Date();
      Date var2 = var5.parse(var0.getCreatedAt());
      var3.setCreateDate(var2);
      var5.parse(var0.getUpdatedAt());
      return var3;
   }

   private static Map a(List var0) {
      HashMap var1 = Maps.newHashMap();
      Iterator var3 = var0.iterator();

      while(var3.hasNext()) {
         CloudOSFlavor var2 = (CloudOSFlavor)var3.next();
         var1.put(var2.getId(), var2);
      }

      return var1;
   }

   public List queryVms(byte var1) {
      ArrayList var2 = new ArrayList();

      try {
         CloudOSClient var3 = new CloudOSClient(this.cloud, this.a);
         Throwable var4 = null;
         boolean var18 = false;

         try {
            var18 = true;
            long var11 = this.cloud.getId().longValue();
            List var8 = var3.getAllTemplets();
            Map var5 = this.a((List)var8, var11);
            var11 = this.cloud.getId().longValue();
            Map var6 = a((List)var3.getAllFlavors());
            if((var1 & 10) != 0) {
               var11 = this.cloud.getId().longValue();
               List var7 = var3.getAllDomains();
               var2.addAll(this.a((List)var7, var11, (Map)var5, (Map)var6));
            }

            if((var1 & 1) != 0) {
               var2.addAll(var5.values());
               var18 = false;
            } else {
               var18 = false;
            }
         } catch (Throwable var20) {
            var4 = var20;
            throw var20;
         } finally {
            if(var18) {
               if(var4 != null) {
                  try {
                     var3.close();
                  } catch (Throwable var19) {
                     var4.addSuppressed(var19);
                  }
               } else {
                  var3.close();
               }

            }
         }

         var3.close();
         return var2;
      } catch (AppException var22) {
         b.error((Object)null, var22);
         throw var22;
      } catch (Exception var23) {
         b.error((Object)null, var23);
         throw new AppException(11008, var23);
      }
   }

   private List a(CloudOSClient var1, long var2, Map var4, Map var5) {
      List var11 = var1.getAllDomains();
      Map var10003 = var4;
      var4 = var5;
      Map var3 = var10003;
      long var9 = var2;
      List var13 = var11;
      ArrayList var12 = Lists.newArrayList();
      Iterator var14 = var13.iterator();

      while(var14.hasNext()) {
         CloudOSVm var15;
         String var6 = (var15 = (CloudOSVm)var14.next()).getFlavor().getId();
         CloudOSFlavor var17 = (CloudOSFlavor)var4.get(var6);
         String var7 = var15.getImage().getId();
         Domain var18 = (Domain)var3.get(var7);
         Domain var16 = a((CloudOSVm)var15, var9, (CloudOSFlavor)var17, (Domain)var18);
         var12.add(var16);
      }

      return var12;
   }

   private Map a(CloudOSClient var1, long var2) {
      List var9 = var1.getAllTemplets();
      long var7 = var2;
      List var11 = var9;
      HashMap var10 = Maps.newHashMap();
      Iterator var12 = var11.iterator();

      while(var12.hasNext()) {
         CloudOSTemplet var3;
         Domain var4 = a((CloudOSTemplet)(var3 = (CloudOSTemplet)var12.next()), var7);
         var10.put(var3.getId(), var4);
      }

      return var10;
   }

   private Map b(CloudOSClient var1, long var2) {
      List var4 = var1.getAllFlavors();
      HashMap var6 = Maps.newHashMap();
      Iterator var5 = var4.iterator();

      while(var5.hasNext()) {
         CloudOSFlavor var3 = (CloudOSFlavor)var5.next();
         var6.put(var3.getId(), var3);
      }

      return var6;
   }

   public void testConnection() {
      String var1 = this.cloud.getProtocal() + "://" + this.cloud.getUri() + ":" + this.cloud.getPort();
      this.a.closeConnection(var1, this.cloud.getUserName());

      try {
         CloudOSClient var2 = new CloudOSClient(this.cloud, this.a);
         Throwable var3 = null;
         boolean var10 = false;

         try {
            var10 = true;
            if(!var2.testConnection()) {
               b.error(String.format("Failed to connect CloudOS \'%s\'", new Object[]{this.cloud.getName()}));
               this.a.closeConnection(var1, this.cloud.getUserName());
               throw new AppException(11008);
            }

            String var4 = var2.getProjectId();
            this.cloud.setTenantId(var4);
            var10 = false;
         } catch (Throwable var12) {
            var3 = var12;
            throw var12;
         } finally {
            if(var10) {
               if(var3 != null) {
                  try {
                     var2.close();
                  } catch (Throwable var11) {
                     var3.addSuppressed(var11);
                  }
               } else {
                  var2.close();
               }

            }
         }

         var2.close();
      } catch (AppException var14) {
         b.error((Object)null, var14);
         this.a.closeConnection(var1, this.cloud.getUserName());
         throw new AppException(11008);
      } catch (Exception var15) {
         b.error((Object)null, var15);
         this.a.closeConnection(var1, this.cloud.getUserName());
         throw new AppException(11008);
      }
   }

   public List queryNetworks() {
      Object var1 = new ArrayList();

      try {
         CloudOSClient var2 = new CloudOSClient(this.cloud, this.a);
         Throwable var3 = null;
         boolean var14 = false;

         try {
            var14 = true;
            Map var4 = a((CloudOSClient)var2);
            Iterator var5 = (var1 = var2.getAllNetworks()).iterator();

            label93:
            while(true) {
               if(var5.hasNext()) {
                  CloudOSNetwork var6;
                  Iterator var7 = (var6 = (CloudOSNetwork)var5.next()).getSubnetIds().iterator();

                  while(true) {
                     if(!var7.hasNext()) {
                        continue label93;
                     }

                     String var8 = (String)var7.next();
                     CloudOSSubnet var20;
                     if((var20 = (CloudOSSubnet)var4.get(var8)) != null) {
                        var6.addSubnet(var20);
                        var6.setCidr(var20.getCidr());
                     }
                  }
               }

               var14 = false;
               break;
            }
         } catch (Throwable var16) {
            var3 = var16;
            throw var16;
         } finally {
            if(var14) {
               if(var3 != null) {
                  try {
                     var2.close();
                  } catch (Throwable var15) {
                     var3.addSuppressed(var15);
                  }
               } else {
                  var2.close();
               }

            }
         }

         var2.close();
      } catch (AppException var18) {
         b.error(var18);
      } catch (Exception var19) {
         b.error(var19);
      }

      return (List)var1;
   }

   private static Map a(CloudOSClient var0) {
      HashMap var1 = Maps.newHashMap();
      Iterator var3 = var0.getAllSubnets().iterator();

      while(var3.hasNext()) {
         CloudOSSubnet var2 = (CloudOSSubnet)var3.next();
         var1.put(var2.getId(), var2);
      }

      return var1;
   }

   public String getFlavorId(int param1, long param2, long param4) {
      // $FF: Couldn't be decompiled
   }

   private static Map a(CloudOSTemplet var0) {
      HashMap var1;
      (var1 = Maps.newHashMap()).put("2481e874-00d8-457e-899c-e628356ea5a1", Double.valueOf(Integer.valueOf(var0.getMinCpu()).doubleValue()));
      var1.put("97e87a80-0f9b-4b64-b0f5-c4d8392ded0a", Double.valueOf((double)var0.getMinRam() / 1024.0D));
      var1.put("ab222fec-6a46-4496-9273-47da58598837", Double.valueOf(Integer.valueOf(var0.getMinDisk()).doubleValue()));
      return var1;
   }

   private static Map a(List var0, Map var1) {
      HashMap var2 = Maps.newHashMap();
      Iterator var6 = var0.iterator();

      while(var6.hasNext()) {
         CloudOSFlavorBasic var3;
         String var4 = (var3 = (CloudOSFlavorBasic)var6.next()).getSubNormUuid();
         Object var5 = Sets.newHashSet();
         if(!var2.containsKey(var4)) {
            var2.put(var4, var5);
         } else {
            var5 = (Set)var2.get(var4);
         }

         String var7 = var3.getBasicContent().getNormValue();
         if(!var1.containsKey(var4) || ((Double)var1.get(var4)).doubleValue() <= Double.parseDouble(var7)) {
            ((Set)var5).add(var7);
         }
      }

      return var2;
   }

   private static Set a(List var0, Map var1, Map var2) {
      HashSet var3 = Sets.newHashSet();
      Iterator var12 = var0.iterator();

      label58:
      while(var12.hasNext()) {
         CloudOSFlavorAdvance var4;
         if((var4 = (CloudOSFlavorAdvance)var12.next()).getAdvContents() != null) {
            HashMap var5 = Maps.newHashMap();
            boolean var6 = true;
            Iterator var13 = var4.getAdvContents().iterator();

            while(true) {
               String var9;
               if(var13.hasNext()) {
                  CloudOSAdvContent var7;
                  String var8 = (var7 = (CloudOSAdvContent)var13.next()).getUuid();
                  var9 = var7.getValue().toString();
                  if("any".equals(var9)) {
                     var5.put(var8, var1.get(var8));
                     continue;
                  }

                  if(!var2.containsKey(var8) || ((Double)var2.get(var8)).doubleValue() <= Double.parseDouble(var9)) {
                     var5.put(var8, Sets.newHashSet(new String[]{var9}));
                     continue;
                  }

                  var6 = false;
               }

               if(!var6) {
                  break;
               }

               var13 = ((Set)var5.get("2481e874-00d8-457e-899c-e628356ea5a1")).iterator();

               while(true) {
                  if(!var13.hasNext()) {
                     continue label58;
                  }

                  String var15 = (String)var13.next();
                  Iterator var16 = ((Set)var5.get("97e87a80-0f9b-4b64-b0f5-c4d8392ded0a")).iterator();

                  while(var16.hasNext()) {
                     var9 = (String)var16.next();
                     Iterator var14 = ((Set)var5.get("ab222fec-6a46-4496-9273-47da58598837")).iterator();

                     while(var14.hasNext()) {
                        String var10 = (String)var14.next();
                        CloudOSFlavor var11;
                        (var11 = new CloudOSFlavor()).setVcpus(Integer.parseInt(var15));
                        var11.setRam(Integer.parseInt(var9));
                        var11.setDisk(Integer.parseInt(var10));
                        var3.add(var11);
                     }
                  }
               }
            }
         }
      }

      return var3;
   }

   public List queryFlavors(CloudOSTemplet var1) {
      ArrayList var2 = Lists.newArrayList();

      try {
         CloudOSClient var3 = new CloudOSClient(this.cloud, this.a);
         Throwable var4 = null;
         boolean var21 = false;

         ArrayList var31;
         label260: {
            ArrayList var28;
            label287: {
               try {
                  var21 = true;
                  String var5;
                  if((var5 = var3.getServiceId()) == null) {
                     b.error("can not get cloudos service id");
                     var31 = var2;
                     var21 = false;
                     break label260;
                  }

                  CloudOSResource var29;
                  if((var29 = var3.getFlavorContents(var5)) == null) {
                     var28 = var2;
                     var21 = false;
                     break label287;
                  }

                  CloudOSTemplet var6 = var1;
                  HashMap var27;
                  (var27 = Maps.newHashMap()).put("2481e874-00d8-457e-899c-e628356ea5a1", Double.valueOf(Integer.valueOf(var6.getMinCpu()).doubleValue()));
                  var27.put("97e87a80-0f9b-4b64-b0f5-c4d8392ded0a", Double.valueOf((double)var6.getMinRam() / 1024.0D));
                  var27.put("ab222fec-6a46-4496-9273-47da58598837", Double.valueOf(Integer.valueOf(var6.getMinDisk()).doubleValue()));
                  List var10000 = var29.getBasics();
                  HashMap var7 = var27;
                  List var32 = var10000;
                  HashMap var8 = Maps.newHashMap();
                  Iterator var9 = var32.iterator();

                  while(true) {
                     String var10;
                     if(!var9.hasNext()) {
                        var10000 = var29.getAdvances();
                        var27 = var27;
                        var7 = var8;
                        var32 = var10000;
                        HashSet var37 = Sets.newHashSet();
                        Iterator var34 = var32.iterator();

                        while(var34.hasNext()) {
                           CloudOSFlavorAdvance var38;
                           if((var38 = (CloudOSFlavorAdvance)var34.next()).getAdvContents() != null) {
                              HashMap var40 = Maps.newHashMap();
                              boolean var41 = true;
                              Iterator var30 = var38.getAdvContents().iterator();

                              String var13;
                              while(var30.hasNext()) {
                                 CloudOSAdvContent var35;
                                 var10 = (var35 = (CloudOSAdvContent)var30.next()).getUuid();
                                 var13 = var35.getValue().toString();
                                 if("any".equals(var13)) {
                                    var40.put(var10, var7.get(var10));
                                 } else {
                                    if(var27.containsKey(var10) && ((Double)var27.get(var10)).doubleValue() > Double.parseDouble(var13)) {
                                       var41 = false;
                                       break;
                                    }

                                    var40.put(var10, Sets.newHashSet(new String[]{var13}));
                                 }
                              }

                              if(var41) {
                                 var30 = ((Set)var40.get("2481e874-00d8-457e-899c-e628356ea5a1")).iterator();

                                 while(var30.hasNext()) {
                                    String var36 = (String)var30.next();
                                    Iterator var39 = ((Set)var40.get("97e87a80-0f9b-4b64-b0f5-c4d8392ded0a")).iterator();

                                    while(var39.hasNext()) {
                                       var13 = (String)var39.next();
                                       Iterator var42 = ((Set)var40.get("ab222fec-6a46-4496-9273-47da58598837")).iterator();

                                       while(var42.hasNext()) {
                                          String var14 = (String)var42.next();
                                          CloudOSFlavor var15;
                                          (var15 = new CloudOSFlavor()).setVcpus(Integer.parseInt(var36));
                                          var15.setRam(Integer.parseInt(var13));
                                          var15.setDisk(Integer.parseInt(var14));
                                          var37.add(var15);
                                       }
                                    }
                                 }
                              }
                           }
                        }

                        var2.addAll(var37);
                        Collections.sort(var2);
                        var21 = false;
                        break;
                     }

                     CloudOSFlavorBasic var33;
                     var10 = (var33 = (CloudOSFlavorBasic)var9.next()).getSubNormUuid();
                     Object var11 = Sets.newHashSet();
                     if(!var8.containsKey(var10)) {
                        var8.put(var10, var11);
                     } else {
                        var11 = (Set)var8.get(var10);
                     }

                     String var12 = var33.getBasicContent().getNormValue();
                     if(!var7.containsKey(var10) || ((Double)var7.get(var10)).doubleValue() <= Double.parseDouble(var12)) {
                        ((Set)var11).add(var12);
                     }
                  }
               } catch (Throwable var23) {
                  var4 = var23;
                  throw var23;
               } finally {
                  if(var21) {
                     if(var4 != null) {
                        try {
                           var3.close();
                        } catch (Throwable var22) {
                           var4.addSuppressed(var22);
                        }
                     } else {
                        var3.close();
                     }

                  }
               }

               var3.close();
               return var2;
            }

            var3.close();
            return var28;
         }

         var3.close();
         return var31;
      } catch (AppException var25) {
         b.error((Object)null, var25);
      } catch (Exception var26) {
         b.error((Object)null, var26);
      }

      return var2;
   }

   public boolean checkTemplate(String var1) {
      return false;
   }

   public String deployDomain(DeployedDomain var1) {
      try {
         CloudOSClient var2 = new CloudOSClient(this.cloud, this.a);
         Throwable var3 = null;
         boolean var10 = false;

         String var16;
         try {
            var10 = true;
            DeployedPacking var4;
            (var4 = new DeployedPacking()).setDomain(var1);
            var16 = var2.deployDomain(var4);
            var10 = false;
         } catch (Throwable var12) {
            var3 = var12;
            throw var12;
         } finally {
            if(var10) {
               if(var3 != null) {
                  try {
                     var2.close();
                  } catch (Throwable var11) {
                     var3.addSuppressed(var11);
                  }
               } else {
                  var2.close();
               }

            }
         }

         var2.close();
         return var16;
      } catch (AppException var14) {
         b.error(var14);
      } catch (Exception var15) {
         b.error(var15);
      }

      return null;
   }

   public CloudOSVmStatus getVmStatus(String var1) {
      try {
         CloudOSClient var2 = new CloudOSClient(this.cloud, this.a);
         Throwable var3 = null;
         boolean var9 = false;

         CloudOSVmStatus var15;
         try {
            var9 = true;
            var15 = var2.getVmStatus(var1);
            var9 = false;
         } catch (Throwable var11) {
            var3 = var11;
            throw var11;
         } finally {
            if(var9) {
               if(var3 != null) {
                  try {
                     var2.close();
                  } catch (Throwable var10) {
                     var3.addSuppressed(var10);
                  }
               } else {
                  var2.close();
               }

            }
         }

         var2.close();
         return var15;
      } catch (AppException var13) {
         b.error(var13);
      } catch (Exception var14) {
         b.error(var14);
      }

      return new CloudOSVmStatus();
   }

   public List queryAzones() {
      try {
         CloudOSClient var1 = new CloudOSClient(this.cloud, this.a);
         Throwable var2 = null;
         boolean var9 = false;

         List var3;
         try {
            var9 = true;
            var3 = var1.getAzones();
            var9 = false;
         } catch (Throwable var11) {
            var2 = var11;
            throw var11;
         } finally {
            if(var9) {
               if(var2 != null) {
                  try {
                     var1.close();
                  } catch (Throwable var10) {
                     var2.addSuppressed(var10);
                  }
               } else {
                  var1.close();
               }

            }
         }

         var1.close();
         return var3;
      } catch (AppException var13) {
         b.error(var13);
         throw var13;
      } catch (Exception var14) {
         b.error(var14);
         throw new AppException(11, var14);
      }
   }

   public Domain queryVm(String var1) {
      try {
         CloudOSClient var2 = new CloudOSClient(this.cloud, this.a);
         Throwable var3 = null;
         boolean var13 = false;

         Domain var20;
         try {
            var13 = true;
            long var4 = this.cloud.getId().longValue();
            CloudOSVm var19;
            String var6 = (var19 = var2.queryVm(var1)).getFlavor().getId();
            CloudOSFlavor var21 = var2.queryFlavor(var6);
            String var7 = var19.getImage().getId();
            Domain var22 = a((CloudOSTemplet)var2.queryTemplet(var7), var4);
            var20 = a((CloudOSVm)var19, var4, (CloudOSFlavor)var21, (Domain)var22);
            var13 = false;
         } catch (Throwable var15) {
            var3 = var15;
            throw var15;
         } finally {
            if(var13) {
               if(var3 != null) {
                  try {
                     var2.close();
                  } catch (Throwable var14) {
                     var3.addSuppressed(var14);
                  }
               } else {
                  var2.close();
               }

            }
         }

         var2.close();
         return var20;
      } catch (AppException var17) {
         b.error(var17);
      } catch (Exception var18) {
         b.error(var18);
      }

      return new Domain();
   }

   public RpcResult operatorDomain(String var1, String var2) {
      try {
         CloudOSClient var3 = new CloudOSClient(this.cloud, this.a);
         Throwable var4 = null;
         boolean var11 = false;

         RpcResult var18;
         label176: {
            label175: {
               label174: {
                  try {
                     var11 = true;
                     byte var5 = -1;
                     switch(var2.hashCode()) {
                     case -1661628965:
                        if(var2.equals("suspended")) {
                           var5 = 2;
                        }
                        break;
                     case -934352412:
                        if(var2.equals("revert")) {
                           var5 = 3;
                        }
                        break;
                     case 94756344:
                        if(var2.equals("close")) {
                           var5 = 1;
                        }
                        break;
                     case 109757538:
                        if(var2.equals("start")) {
                           var5 = 0;
                        }
                        break;
                     case 1097506319:
                        if(var2.equals("restart")) {
                           var5 = 4;
                        }
                     }

                     String var10000;
                     switch(var5) {
                     case 0:
                        var10000 = "{\"os-start\":null}";
                        break;
                     case 1:
                        var10000 = "{\"os-stop\":null}";
                        break;
                     case 2:
                        var10000 = "{\"suspend\":null}";
                        break;
                     case 3:
                        var10000 = "{\"resume\":null}";
                        break;
                     case 4:
                        var10000 = "{\"os-reboot\":{\"type\": \"HARD\"}}";
                        break;
                     default:
                        var10000 = null;
                     }

                     var2 = var10000;
                     if(var10000 == null) {
                        var18 = new RpcResult("Operation %s is not support temporarily");
                        var11 = false;
                        break label175;
                     }

                     RespEntity var17;
                     switch((var17 = var3.operVm(var1, var2)).getStatusCode()) {
                     case 202:
                        var18 = new RpcResult(Boolean.valueOf(true));
                        var11 = false;
                        break label174;
                     case 404:
                        var18 = new RpcResult(ErrorCodes.getErrorMessage(1001), 1001);
                        var11 = false;
                        break;
                     default:
                        var18 = new RpcResult(var17.getErrMsg());
                        var11 = false;
                        break label176;
                     }
                  } catch (Throwable var13) {
                     var4 = var13;
                     throw var13;
                  } finally {
                     if(var11) {
                        if(var4 != null) {
                           try {
                              var3.close();
                           } catch (Throwable var12) {
                              var4.addSuppressed(var12);
                           }
                        } else {
                           var3.close();
                        }

                     }
                  }

                  var3.close();
                  return var18;
               }

               var3.close();
               return var18;
            }

            var3.close();
            return var18;
         }

         var3.close();
         return var18;
      } catch (AppException var15) {
         b.error((Object)null, var15);
         return new RpcResult(var15.getErrorMessage());
      } catch (Exception var16) {
         b.error((Object)null, var16);
         return new RpcResult(var16.getLocalizedMessage());
      }
   }

   private static String a(String var0) {
      byte var1 = -1;
      switch(var0.hashCode()) {
      case -1661628965:
         if(var0.equals("suspended")) {
            var1 = 2;
         }
         break;
      case -934352412:
         if(var0.equals("revert")) {
            var1 = 3;
         }
         break;
      case 94756344:
         if(var0.equals("close")) {
            var1 = 1;
         }
         break;
      case 109757538:
         if(var0.equals("start")) {
            var1 = 0;
         }
         break;
      case 1097506319:
         if(var0.equals("restart")) {
            var1 = 4;
         }
      }

      switch(var1) {
      case 0:
         return "{\"os-start\":null}";
      case 1:
         return "{\"os-stop\":null}";
      case 2:
         return "{\"suspend\":null}";
      case 3:
         return "{\"resume\":null}";
      case 4:
         return "{\"os-reboot\":{\"type\": \"HARD\"}}";
      default:
         return null;
      }
   }

   public Map getResourceOverview(String var1) {
      return null;
   }

   public String getDomainStatus(String var1) {
      try {
         CloudOSClient var2 = new CloudOSClient(this.cloud, this.a);
         Throwable var3 = null;
         boolean var9 = false;

         try {
            var9 = true;
            CloudOSVmStatus.getCicStatus(var2.getVmStatus(var1).getVmStatus());
            var9 = false;
         } catch (Throwable var11) {
            var3 = var11;
            throw var11;
         } finally {
            if(var9) {
               if(var3 != null) {
                  try {
                     var2.close();
                  } catch (Throwable var10) {
                     var3.addSuppressed(var10);
                  }
               } else {
                  var2.close();
               }

            }
         }

         var2.close();
      } catch (AppException var13) {
         b.error(var13);
      } catch (Exception var14) {
         b.error(var14);
      }

      return "unknown";
   }

   public List queryStorageRes(PublicCloud var1, String var2) {
      return null;
   }

   public List queryHostpools() {
      return Lists.newArrayList();
   }

   public List queryClusters() {
      return Lists.newArrayList();
   }

   public List queryHosts() {
      return Lists.newArrayList();
   }

   public CpuAndMemory queryClusterCpuAndMemory(String var1) {
      return null;
   }

   public List queryAllCloudClusterByHostpoolId(Long var1) {
      return null;
   }

   public List queryHostsByCondition(Long var1, Long var2) {
      return null;
   }

   public List queryAllHosts() {
      return null;
   }

   public List queryAllClusters() {
      return null;
   }

   public ResourcePoolPo queryClusterSummaryInfo(String var1) {
      return null;
   }

   public List queryStorageInCluster(String var1, Boolean var2) {
      return null;
   }

   public double queryClusterCpuRate(String var1) {
      return 0.0D;
   }

   public double queryClusterMemoryRate(String var1) {
      return 0.0D;
   }

   public List queryProfile() {
      return null;
   }

   public List queryNet(String var1) {
      return null;
   }

   public List queryVirtHostTop5Rate(String var1, String var2) {
      return null;
   }

   public List queryComputeResourceTrend(String var1, String var2) {
      return null;
   }

   public StoragePo queryStorageBaseInfo(String var1) {
      return null;
   }

   public List queryVmStorageInfo(List var1, String var2, String var3) {
      return null;
   }

   public List queryStorageHistory(String var1) {
      return null;
   }

   public Map queryOrgStorageInfo(List var1, String var2, String var3) {
      return null;
   }

   public List queryStorageList(List var1, Cluster var2) {
      return null;
   }

   public void checkCluster(String var1) {
   }

   public List queryIORwAndIOPSTrend(String var1, String var2, String var3) {
      return null;
   }

   public List queryOrgVmStorageInfo(List var1, List var2) {
      return null;
   }

   public List queryStoragePerfTrend(String var1, String var2) {
      return null;
   }

}
